/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataMongodbatlasBackupCompliancePolicyConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.11.0/docs/data-sources/backup_compliance_policy#id DataMongodbatlasBackupCompliancePolicy#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.11.0/docs/data-sources/backup_compliance_policy#project_id DataMongodbatlasBackupCompliancePolicy#project_id}
    */
    readonly projectId: string;
    /**
    * on_demand_policy_item block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.11.0/docs/data-sources/backup_compliance_policy#on_demand_policy_item DataMongodbatlasBackupCompliancePolicy#on_demand_policy_item}
    */
    readonly onDemandPolicyItem?: DataMongodbatlasBackupCompliancePolicyOnDemandPolicyItem;
    /**
    * policy_item_daily block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.11.0/docs/data-sources/backup_compliance_policy#policy_item_daily DataMongodbatlasBackupCompliancePolicy#policy_item_daily}
    */
    readonly policyItemDaily?: DataMongodbatlasBackupCompliancePolicyPolicyItemDaily;
    /**
    * policy_item_hourly block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.11.0/docs/data-sources/backup_compliance_policy#policy_item_hourly DataMongodbatlasBackupCompliancePolicy#policy_item_hourly}
    */
    readonly policyItemHourly?: DataMongodbatlasBackupCompliancePolicyPolicyItemHourly;
    /**
    * policy_item_monthly block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.11.0/docs/data-sources/backup_compliance_policy#policy_item_monthly DataMongodbatlasBackupCompliancePolicy#policy_item_monthly}
    */
    readonly policyItemMonthly?: DataMongodbatlasBackupCompliancePolicyPolicyItemMonthly[] | cdktf.IResolvable;
    /**
    * policy_item_weekly block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.11.0/docs/data-sources/backup_compliance_policy#policy_item_weekly DataMongodbatlasBackupCompliancePolicy#policy_item_weekly}
    */
    readonly policyItemWeekly?: DataMongodbatlasBackupCompliancePolicyPolicyItemWeekly[] | cdktf.IResolvable;
}
export interface DataMongodbatlasBackupCompliancePolicyOnDemandPolicyItem {
}
export declare function dataMongodbatlasBackupCompliancePolicyOnDemandPolicyItemToTerraform(struct?: DataMongodbatlasBackupCompliancePolicyOnDemandPolicyItemOutputReference | DataMongodbatlasBackupCompliancePolicyOnDemandPolicyItem): any;
export declare class DataMongodbatlasBackupCompliancePolicyOnDemandPolicyItemOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataMongodbatlasBackupCompliancePolicyOnDemandPolicyItem | undefined;
    set internalValue(value: DataMongodbatlasBackupCompliancePolicyOnDemandPolicyItem | undefined);
    get frequencyInterval(): number;
    get frequencyType(): string;
    get id(): string;
    get retentionUnit(): string;
    get retentionValue(): number;
}
export interface DataMongodbatlasBackupCompliancePolicyPolicyItemDaily {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.11.0/docs/data-sources/backup_compliance_policy#frequency_interval DataMongodbatlasBackupCompliancePolicy#frequency_interval}
    */
    readonly frequencyInterval: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.11.0/docs/data-sources/backup_compliance_policy#retention_unit DataMongodbatlasBackupCompliancePolicy#retention_unit}
    */
    readonly retentionUnit: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.11.0/docs/data-sources/backup_compliance_policy#retention_value DataMongodbatlasBackupCompliancePolicy#retention_value}
    */
    readonly retentionValue: number;
}
export declare function dataMongodbatlasBackupCompliancePolicyPolicyItemDailyToTerraform(struct?: DataMongodbatlasBackupCompliancePolicyPolicyItemDailyOutputReference | DataMongodbatlasBackupCompliancePolicyPolicyItemDaily): any;
export declare class DataMongodbatlasBackupCompliancePolicyPolicyItemDailyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataMongodbatlasBackupCompliancePolicyPolicyItemDaily | undefined;
    set internalValue(value: DataMongodbatlasBackupCompliancePolicyPolicyItemDaily | undefined);
    private _frequencyInterval?;
    get frequencyInterval(): number;
    set frequencyInterval(value: number);
    get frequencyIntervalInput(): number | undefined;
    get frequencyType(): string;
    get id(): string;
    private _retentionUnit?;
    get retentionUnit(): string;
    set retentionUnit(value: string);
    get retentionUnitInput(): string | undefined;
    private _retentionValue?;
    get retentionValue(): number;
    set retentionValue(value: number);
    get retentionValueInput(): number | undefined;
}
export interface DataMongodbatlasBackupCompliancePolicyPolicyItemHourly {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.11.0/docs/data-sources/backup_compliance_policy#frequency_interval DataMongodbatlasBackupCompliancePolicy#frequency_interval}
    */
    readonly frequencyInterval: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.11.0/docs/data-sources/backup_compliance_policy#retention_unit DataMongodbatlasBackupCompliancePolicy#retention_unit}
    */
    readonly retentionUnit: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.11.0/docs/data-sources/backup_compliance_policy#retention_value DataMongodbatlasBackupCompliancePolicy#retention_value}
    */
    readonly retentionValue: number;
}
export declare function dataMongodbatlasBackupCompliancePolicyPolicyItemHourlyToTerraform(struct?: DataMongodbatlasBackupCompliancePolicyPolicyItemHourlyOutputReference | DataMongodbatlasBackupCompliancePolicyPolicyItemHourly): any;
export declare class DataMongodbatlasBackupCompliancePolicyPolicyItemHourlyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataMongodbatlasBackupCompliancePolicyPolicyItemHourly | undefined;
    set internalValue(value: DataMongodbatlasBackupCompliancePolicyPolicyItemHourly | undefined);
    private _frequencyInterval?;
    get frequencyInterval(): number;
    set frequencyInterval(value: number);
    get frequencyIntervalInput(): number | undefined;
    get frequencyType(): string;
    get id(): string;
    private _retentionUnit?;
    get retentionUnit(): string;
    set retentionUnit(value: string);
    get retentionUnitInput(): string | undefined;
    private _retentionValue?;
    get retentionValue(): number;
    set retentionValue(value: number);
    get retentionValueInput(): number | undefined;
}
export interface DataMongodbatlasBackupCompliancePolicyPolicyItemMonthly {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.11.0/docs/data-sources/backup_compliance_policy#frequency_interval DataMongodbatlasBackupCompliancePolicy#frequency_interval}
    */
    readonly frequencyInterval: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.11.0/docs/data-sources/backup_compliance_policy#retention_unit DataMongodbatlasBackupCompliancePolicy#retention_unit}
    */
    readonly retentionUnit: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.11.0/docs/data-sources/backup_compliance_policy#retention_value DataMongodbatlasBackupCompliancePolicy#retention_value}
    */
    readonly retentionValue: number;
}
export declare function dataMongodbatlasBackupCompliancePolicyPolicyItemMonthlyToTerraform(struct?: DataMongodbatlasBackupCompliancePolicyPolicyItemMonthly | cdktf.IResolvable): any;
export declare class DataMongodbatlasBackupCompliancePolicyPolicyItemMonthlyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasBackupCompliancePolicyPolicyItemMonthly | cdktf.IResolvable | undefined;
    set internalValue(value: DataMongodbatlasBackupCompliancePolicyPolicyItemMonthly | cdktf.IResolvable | undefined);
    private _frequencyInterval?;
    get frequencyInterval(): number;
    set frequencyInterval(value: number);
    get frequencyIntervalInput(): number | undefined;
    get frequencyType(): string;
    get id(): string;
    private _retentionUnit?;
    get retentionUnit(): string;
    set retentionUnit(value: string);
    get retentionUnitInput(): string | undefined;
    private _retentionValue?;
    get retentionValue(): number;
    set retentionValue(value: number);
    get retentionValueInput(): number | undefined;
}
export declare class DataMongodbatlasBackupCompliancePolicyPolicyItemMonthlyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataMongodbatlasBackupCompliancePolicyPolicyItemMonthly[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasBackupCompliancePolicyPolicyItemMonthlyOutputReference;
}
export interface DataMongodbatlasBackupCompliancePolicyPolicyItemWeekly {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.11.0/docs/data-sources/backup_compliance_policy#frequency_interval DataMongodbatlasBackupCompliancePolicy#frequency_interval}
    */
    readonly frequencyInterval: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.11.0/docs/data-sources/backup_compliance_policy#retention_unit DataMongodbatlasBackupCompliancePolicy#retention_unit}
    */
    readonly retentionUnit: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.11.0/docs/data-sources/backup_compliance_policy#retention_value DataMongodbatlasBackupCompliancePolicy#retention_value}
    */
    readonly retentionValue: number;
}
export declare function dataMongodbatlasBackupCompliancePolicyPolicyItemWeeklyToTerraform(struct?: DataMongodbatlasBackupCompliancePolicyPolicyItemWeekly | cdktf.IResolvable): any;
export declare class DataMongodbatlasBackupCompliancePolicyPolicyItemWeeklyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasBackupCompliancePolicyPolicyItemWeekly | cdktf.IResolvable | undefined;
    set internalValue(value: DataMongodbatlasBackupCompliancePolicyPolicyItemWeekly | cdktf.IResolvable | undefined);
    private _frequencyInterval?;
    get frequencyInterval(): number;
    set frequencyInterval(value: number);
    get frequencyIntervalInput(): number | undefined;
    get frequencyType(): string;
    get id(): string;
    private _retentionUnit?;
    get retentionUnit(): string;
    set retentionUnit(value: string);
    get retentionUnitInput(): string | undefined;
    private _retentionValue?;
    get retentionValue(): number;
    set retentionValue(value: number);
    get retentionValueInput(): number | undefined;
}
export declare class DataMongodbatlasBackupCompliancePolicyPolicyItemWeeklyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataMongodbatlasBackupCompliancePolicyPolicyItemWeekly[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasBackupCompliancePolicyPolicyItemWeeklyOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.11.0/docs/data-sources/backup_compliance_policy mongodbatlas_backup_compliance_policy}
*/
export declare class DataMongodbatlasBackupCompliancePolicy extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "mongodbatlas_backup_compliance_policy";
    /**
    * Create a new {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.11.0/docs/data-sources/backup_compliance_policy mongodbatlas_backup_compliance_policy} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataMongodbatlasBackupCompliancePolicyConfig
    */
    constructor(scope: Construct, id: string, config: DataMongodbatlasBackupCompliancePolicyConfig);
    get authorizedEmail(): string;
    get copyProtectionEnabled(): cdktf.IResolvable;
    get encryptionAtRestEnabled(): cdktf.IResolvable;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get pitEnabled(): cdktf.IResolvable;
    private _projectId?;
    get projectId(): string;
    set projectId(value: string);
    get projectIdInput(): string | undefined;
    get restoreWindowDays(): number;
    get state(): string;
    get updatedDate(): string;
    get updatedUser(): string;
    private _onDemandPolicyItem;
    get onDemandPolicyItem(): DataMongodbatlasBackupCompliancePolicyOnDemandPolicyItemOutputReference;
    putOnDemandPolicyItem(value: DataMongodbatlasBackupCompliancePolicyOnDemandPolicyItem): void;
    resetOnDemandPolicyItem(): void;
    get onDemandPolicyItemInput(): DataMongodbatlasBackupCompliancePolicyOnDemandPolicyItem | undefined;
    private _policyItemDaily;
    get policyItemDaily(): DataMongodbatlasBackupCompliancePolicyPolicyItemDailyOutputReference;
    putPolicyItemDaily(value: DataMongodbatlasBackupCompliancePolicyPolicyItemDaily): void;
    resetPolicyItemDaily(): void;
    get policyItemDailyInput(): DataMongodbatlasBackupCompliancePolicyPolicyItemDaily | undefined;
    private _policyItemHourly;
    get policyItemHourly(): DataMongodbatlasBackupCompliancePolicyPolicyItemHourlyOutputReference;
    putPolicyItemHourly(value: DataMongodbatlasBackupCompliancePolicyPolicyItemHourly): void;
    resetPolicyItemHourly(): void;
    get policyItemHourlyInput(): DataMongodbatlasBackupCompliancePolicyPolicyItemHourly | undefined;
    private _policyItemMonthly;
    get policyItemMonthly(): DataMongodbatlasBackupCompliancePolicyPolicyItemMonthlyList;
    putPolicyItemMonthly(value: DataMongodbatlasBackupCompliancePolicyPolicyItemMonthly[] | cdktf.IResolvable): void;
    resetPolicyItemMonthly(): void;
    get policyItemMonthlyInput(): cdktf.IResolvable | DataMongodbatlasBackupCompliancePolicyPolicyItemMonthly[] | undefined;
    private _policyItemWeekly;
    get policyItemWeekly(): DataMongodbatlasBackupCompliancePolicyPolicyItemWeeklyList;
    putPolicyItemWeekly(value: DataMongodbatlasBackupCompliancePolicyPolicyItemWeekly[] | cdktf.IResolvable): void;
    resetPolicyItemWeekly(): void;
    get policyItemWeeklyInput(): cdktf.IResolvable | DataMongodbatlasBackupCompliancePolicyPolicyItemWeekly[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
